# Development Report for June 09, 2017

## Docker Schema 1 Pull

We added support for pulling Docker images which use the schema1 manifest
format in the containerd client. This allows pulling images from older
registries as well as images pushed from older versions of Docker. With this
change any image from the Docker Hub or registry supporting the v2 API can be
pulled. As part of our commitment to support OCI images, the schema 1 images
pulled by the client are converted to OCI images before being stored by
containerd. The containerd client will only support pushing these images as
OCI.

[#968 Schema 1 pull](https://github.com/containerd/containerd/pull/968)

## Namespaces for multitenancy

One of the goals of containerd is to support multiple consumers.  The ability to have swarm, docker, kube, and more all running on the same system and using the same containerd without having naming and actions conflict with one another.  We have the namespace API merged in and most of the underlying components updated to support namespaces.  You can view the namespace PR below for more information on the functionality of namespaces.

[namespaces](https://github.com/containerd/containerd/pull/963)

## Client Updates

We added updates to the client to support attach, checkpoint and restore, exec of additional processes, and fixes.  We also ported over the `ctr` and `dist` tools to use the client this week.

[exec](https://github.com/containerd/containerd/pull/940)
[tty](https://github.com/containerd/containerd/pull/948)
[checkpoint](https://github.com/containerd/containerd/pull/958)
[attach](https://github.com/containerd/containerd/pull/976)

# What's Next?

We only have a few features left to implement, such as [events](https://github.com/containerd/containerd/pull/956), for our 1.0 release.  The rest of the month we are working on usability, bug fixes, and stability.

We will be helping out with integrations of containerd into other platforms to make sure that everyone has the functionality that they need.  If you run into any problems please open an issue on github.  Also Pull Requests for the problems you are having are welcome.  If you have any question or help working on a change, stop by the #containerd slack channel as everyone is friendly and helpful.
